(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     38728,       1008]
NotebookOptionsPosition[     38073,        989]
NotebookOutlinePosition[     38447,       1005]
CellTagsIndexPosition[     38404,       1002]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{
   "n", ",", "\[Epsilon]0", ",", "m", ",", "c", ",", "rCyl", ",", "rInt", ",",
     "rExt", ",", "c", ",", "m", ",", "\[Sigma]0"}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "Parameters", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Delta]r", "=", 
    RowBox[{"10", "^", 
     RowBox[{"-", "14"}]}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"Boundary", " ", "displacement"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rCylUnp", " ", "=", 
    RowBox[{"0.25", "*", 
     RowBox[{"10", "^", 
      RowBox[{"-", "6"}]}]}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"Unperturbed", " ", "nanocylinder", " ", "size"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rCyl", "=", "rCylUnp"}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"Unperturbed", " ", "nanocylinder", " ", "size"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rInt", " ", "=", " ", 
   RowBox[{"rCyl", "+", 
    RowBox[{"1.7", "*", 
     RowBox[{"10", "^", 
      RowBox[{"-", "6"}]}]}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Distance", " ", "to", " ", "PML", " ", "domain"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"rExt", " ", "=", " ", 
   RowBox[{"rInt", "+", 
    RowBox[{"1", "*", 
     RowBox[{"10", "^", 
      RowBox[{"-", "6"}]}]}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Distance", " ", "to", " ", "PEC", " ", "boundary"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"n", " ", "=", " ", "3.46"}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"GaAs", " ", "-", " ", 
    RowBox[{"Refractive", " ", "index"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"\[Mu]0", " ", "=", " ", 
   RowBox[{"4", "*", "\[Pi]", "*", 
    RowBox[{"10", "^", 
     RowBox[{"-", "7"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Epsilon]0", " ", "=", " ", 
   RowBox[{"8.85", "*", 
    RowBox[{"10", "^", 
     RowBox[{"-", "12"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c", " ", "=", " ", 
   RowBox[{"1", "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"\[Mu]0", "*", "\[Epsilon]0"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "1"}], ";", "  ", 
  RowBox[{"(*", 
   RowBox[{
   "Azimuthal", " ", "number", " ", "of", " ", "electromagnetic", " ", 
    "solution"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"\[Sigma]0", " ", "=", "5"}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "Attenuation", " ", "constant", " ", "in", " ", "the", " ", "PML"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"\[Omega]0", " ", "=", " ", 
   RowBox[{"2", "*", "\[Pi]", "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"161", "*", 
       RowBox[{"10", "^", "12"}]}], "+", 
      RowBox[{"2", "*", "I", "*", 
       RowBox[{"10", "^", "11"}]}]}], ")"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Frequency", " ", "guess"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.789811440116866*^9, 3.78981149192624*^9}, {
   3.789811549414276*^9, 3.7898115794787984`*^9}, {3.7898116204831057`*^9, 
   3.7898116237832503`*^9}, {3.7898116947116575`*^9, 
   3.7898116957987556`*^9}, {3.789811792435302*^9, 3.7898118245184712`*^9}, {
   3.7898124272349157`*^9, 3.7898124711078987`*^9}, {3.7898126982104855`*^9, 
   3.7898127077659693`*^9}, {3.7898129401949196`*^9, 
   3.7898129413937263`*^9}, {3.7898134484021635`*^9, 
   3.7898134523844204`*^9}, {3.7898134959304266`*^9, 
   3.7898134962428637`*^9}, {3.7898135735739555`*^9, 3.789813736719654*^9}, {
   3.789813832702566*^9, 3.789813833009741*^9}, {3.789813867171054*^9, 
   3.789813876367725*^9}, {3.7898140368421345`*^9, 3.789814036976808*^9}, {
   3.789815633217952*^9, 3.7898156336179075`*^9}, {3.7898157627692986`*^9, 
   3.7898158573751235`*^9}, {3.7898161943044577`*^9, 3.789816228142937*^9}, {
   3.78981630563952*^9, 3.789816317535739*^9}, {3.7898173570317807`*^9, 
   3.7898173720096874`*^9}, {3.789817412233025*^9, 3.78981741279552*^9}, {
   3.7898176313039217`*^9, 3.789817677257987*^9}, 3.789817989385026*^9, {
   3.789818111884243*^9, 3.789818111943119*^9}, {3.789818348126107*^9, 
   3.789818348182953*^9}, 3.789818387682291*^9, {3.7898184613840475`*^9, 
   3.789818497146402*^9}, {3.78981860367633*^9, 3.7898186097171373`*^9}, {
   3.789818650756367*^9, 3.789818650839134*^9}, {3.7898187561194067`*^9, 
   3.7898187675946712`*^9}, {3.7898187993836365`*^9, 
   3.7898187994843397`*^9}, {3.789820029413247*^9, 3.789820029506996*^9}, {
   3.789820207861022*^9, 3.7898202382267685`*^9}, {3.7898247458207865`*^9, 
   3.789824746064191*^9}, {3.7898272538394804`*^9, 3.7898272561654987`*^9}, {
   3.789827299111349*^9, 3.7898272992360153`*^9}, 3.7898273350506487`*^9, 
   3.7898274865818567`*^9, {3.7898276202388105`*^9, 3.789827620339797*^9}, {
   3.789827699065345*^9, 3.7898277207778263`*^9}, {3.7898277569366055`*^9, 
   3.7898277760293694`*^9}, 3.7898278300482106`*^9, {3.7898278680601635`*^9, 
   3.7898279057725983`*^9}, {3.7898284684863815`*^9, 
   3.7898284722458677`*^9}, {3.789828706824417*^9, 3.7898287096060224`*^9}, {
   3.789828760281642*^9, 3.7898288601961474`*^9}, {3.79942438822262*^9, 
   3.7994243924786186`*^9}, {3.799433452579305*^9, 3.799433470369734*^9}, {
   3.799433518612987*^9, 3.799433565267242*^9}, {3.7994337634591074`*^9, 
   3.7994338109946175`*^9}, {3.799437002671249*^9, 3.7994370033743935`*^9}, {
   3.80634654237144*^9, 3.806346602976552*^9}, {3.806347107324649*^9, 
   3.806347107792365*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"86be686d-a79b-427d-aa4a-d89615fb0bb5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[HBar]", "=", 
     RowBox[{"1.05", "*", 
      RowBox[{"10", "^", 
       RowBox[{"-", "34"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"L", " ", "=", " ", 
     RowBox[{"250", "*", 
      RowBox[{"10", "^", 
       RowBox[{"-", "9"}]}]}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Nanocylinder", " ", "height"}], " ", "-", " ", 
     RowBox[{"normalization", " ", "purposes"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", " ", "=", "5317.6"}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"GaAs", " ", "-", " ", "Density"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"GaAs", " ", "-", " ", 
     RowBox[{"Mechanical", " ", "properties"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"c11", " ", "=", " ", 
     RowBox[{"118", "*", 
      RowBox[{"10", "^", "9"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"c12", " ", "=", " ", 
     RowBox[{"53.5", "*", 
      RowBox[{"10", "^", "9"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"GaAs", " ", "-", " ", 
     RowBox[{"Photoelastic", " ", "tensor"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p11", " ", "=", " ", 
     RowBox[{"\[Minus]", "0.165"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p12", "=", 
     RowBox[{"\[Minus]", "0.14"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"p44", "=", " ", 
     RowBox[{"\[Minus]", "0.072"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"GaAs", " ", "-", " ", 
     RowBox[{"Sound", " ", "velocity"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vl", " ", "=", " ", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c11", "/", "\[Rho]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"U", "[", "r_", "]"}], " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"BesselJ", "[", 
        RowBox[{"1", ",", 
         RowBox[{"\[CapitalOmega]", "*", 
          RowBox[{"r", "/", "vl"}]}]}], "]"}], ",", "0", ",", "0"}], "}"}]}], 
    ";", " ", 
    RowBox[{"(*", 
     RowBox[{"Mechanical", " ", "mode", " ", "profile"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"U", "[", "r", "]"}], ".", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", "0", ",", "rCyl"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Unorm", " ", "=", " ", 
     RowBox[{
      RowBox[{"U", "[", "rCyl", "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"Mechanical", " ", "mode", " ", "normalization"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"x", "=", 
     RowBox[{"x", "/.", 
      RowBox[{"FindRoot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"c11", "/", 
           RowBox[{"(", 
            RowBox[{"2", "*", "vl"}], ")"}]}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"BesselJ", "[", 
             RowBox[{"0", ",", 
              RowBox[{"x", "/", "vl"}]}], "]"}], "-", 
            RowBox[{"BesselJ", "[", 
             RowBox[{"2", ",", 
              RowBox[{"x", "/", "vl"}]}], "]"}]}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"c12", "/", "x"}], "*", 
          RowBox[{"BesselJ", "[", 
           RowBox[{"1", ",", 
            RowBox[{"x", "/", "vl"}]}], "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "10080"}], "}"}]}], "]"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Mechanical", " ", "mode"}], " ", "-", " ", 
      RowBox[{"dispersion", " ", "relation"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"\[CapitalOmega]", "=", " ", 
     RowBox[{"x", "/", "rCyl"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"meffnorm", "=", " ", 
     RowBox[{"2", "*", "\[Pi]", "*", "L", "*", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"U", "[", "r", "]"}], ".", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ")"}], "^", "2"}], 
          "/", 
          RowBox[{"Unorm", "^", "2"}]}], "*", "r", "*", "\[Rho]"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "0", ",", "rCyl"}], "}"}]}], "]"}]}]}], ";"}], " ", 
   RowBox[{"(*", 
    RowBox[{"Effective", " ", "dynamic", " ", "mass"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"U", "[", "r_", "]"}], "=", " ", 
     RowBox[{
      RowBox[{"U", "[", "r", "]"}], "/", "Unorm"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Strain", " ", "tensor"}], " ", "-", " ", 
     RowBox[{"Voigt", " ", "notation"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S1", "[", "r_", "]"}], " ", "=", " ", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"U", "[", "r", "]"}], ",", "r"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"S2", " ", "[", "r_", "]"}], "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"U", "[", "r", "]"}], ".", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "/", "r"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xzpf", " ", "=", " ", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"\[HBar]", "/", 
       RowBox[{"(", 
        RowBox[{"2", "*", "meffnorm", "*", "\[CapitalOmega]"}], ")"}]}], 
      "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"Zero", "-", 
      RowBox[{"point", " ", "fluctuation"}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"\[CapitalOmega]", "/", 
     RowBox[{"(", 
      RowBox[{"2", "\[Pi]"}], ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.789811440116866*^9, 3.78981149192624*^9}, {
   3.789811549414276*^9, 3.7898115794787984`*^9}, {3.7898116204831057`*^9, 
   3.7898116237832503`*^9}, {3.7898116947116575`*^9, 
   3.7898116957987556`*^9}, {3.789811792435302*^9, 3.7898118245184712`*^9}, {
   3.7898124272349157`*^9, 3.7898124711078987`*^9}, {3.7898126982104855`*^9, 
   3.7898127077659693`*^9}, {3.7898129401949196`*^9, 
   3.7898129413937263`*^9}, {3.7898134484021635`*^9, 
   3.7898134523844204`*^9}, {3.7898134959304266`*^9, 
   3.7898134962428637`*^9}, {3.7898135735739555`*^9, 3.789813736719654*^9}, {
   3.789813832702566*^9, 3.789813833009741*^9}, {3.789813867171054*^9, 
   3.789813876367725*^9}, {3.7898140368421345`*^9, 3.789814036976808*^9}, {
   3.789815633217952*^9, 3.7898156336179075`*^9}, {3.7898157627692986`*^9, 
   3.7898158573751235`*^9}, {3.7898161943044577`*^9, 3.789816228142937*^9}, {
   3.78981630563952*^9, 3.789816317535739*^9}, {3.7898173570317807`*^9, 
   3.7898173720096874`*^9}, {3.789817412233025*^9, 3.78981741279552*^9}, {
   3.7898176313039217`*^9, 3.789817677257987*^9}, 3.789817989385026*^9, {
   3.789818111884243*^9, 3.789818111943119*^9}, {3.789818348126107*^9, 
   3.789818348182953*^9}, {3.789818387682291*^9, 3.789818392347813*^9}, 
   3.7898191249512887`*^9, {3.7898260822817097`*^9, 3.7898261193465*^9}, {
   3.789828865788148*^9, 3.789828867441662*^9}, {3.806346612181899*^9, 
   3.806346678292613*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"0739c0c9-5bc1-4a58-b921-a515cb629d4d"],

Cell[BoxData["6.417333563077785`*^9"], "Output",
 CellChangeTimes->{
  3.789819129138114*^9, 3.7898200309990034`*^9, {3.789820210250627*^9, 
   3.789820239505379*^9}, {3.789824748265275*^9, 3.7898247512692366`*^9}, 
   3.789826123685886*^9, 3.7898270415857763`*^9, 3.7898272631733646`*^9, 
   3.789827301136958*^9, 3.789827337592679*^9, 3.7898274893516417`*^9, 
   3.7898276223720307`*^9, {3.7898277019429955`*^9, 3.7898277245564327`*^9}, {
   3.7898277604249325`*^9, 3.789827778932399*^9}, {3.789827816484697*^9, 
   3.789827833411586*^9}, {3.789827870179574*^9, 3.789827907775998*^9}, 
   3.7898283901432314`*^9, 3.78982847434184*^9, 3.7898287129313474`*^9, 
   3.789828772545883*^9, 3.7898288361511116`*^9, 3.789828868347348*^9, 
   3.789828904510213*^9, 3.79942439535651*^9, {3.799433455735609*^9, 
   3.7994334715595074`*^9}, {3.799433522153392*^9, 3.799433567556754*^9}, {
   3.7994337654611483`*^9, 3.7994338125082684`*^9}, 3.799437006995139*^9, 
   3.8063468036342735`*^9, 3.8063471103335056`*^9},
 CellLabel->
  "Out[184]=",ExpressionUUID->"4bc3f9ef-8e5b-4c5f-ad7a-635c0c62a2ac"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Do", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"rCyl", " ", "=", " ", 
     RowBox[{"rCylUnp", "+", 
      RowBox[{"ii", "*", "\[Delta]r"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{
       "Solutions", " ", "to", " ", "electromagnetic", " ", "problem", " ", 
        "for", " ", "H", " ", "and", " ", "E", " ", 
        RowBox[{"fields", ".", " ", "Labels"}]}], " ", "-", " ", 
       RowBox[{"in", ":", " ", 
        RowBox[{"inside", " ", "nanocylinder"}]}]}], ",", " ", 
      RowBox[{"out", ":", " ", 
       RowBox[{"air", " ", "domain"}]}], ",", " ", 
      RowBox[{"PML", ":", " ", 
       RowBox[{"PML", " ", "domain"}]}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hin", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], " ", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", " ", 
        RowBox[{"BesselJ", "[", 
         RowBox[{"m", ",", " ", 
          RowBox[{"n", "*", "\[Omega]", "*", 
           RowBox[{"r", "/", "c"}]}]}], "]"}]}], "}"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "I"}], "*", "m", "*", "\[Phi]"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ein", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "/", 
       RowBox[{"(", 
        RowBox[{"I", "*", "\[Omega]", "*", "\[Epsilon]0", "*", 
         RowBox[{"n", "^", "2"}]}], ")"}]}], 
      RowBox[{"Curl", "[", 
       RowBox[{
        RowBox[{"hin", "[", 
         RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "\[Phi]", ",", "z"}], "}"}], ",", " ", 
        "\"\<Cylindrical\>\""}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hout", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], " ", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{
         RowBox[{"A", "*", 
          RowBox[{"BesselJ", "[", 
           RowBox[{"m", ",", " ", 
            RowBox[{"\[Omega]", "*", 
             RowBox[{"r", "/", "c"}]}]}], "]"}]}], " ", "+", " ", 
         RowBox[{"B", "*", 
          RowBox[{"BesselY", "[", 
           RowBox[{"m", ",", " ", 
            RowBox[{"\[Omega]", "*", 
             RowBox[{"r", "/", "c"}]}]}], "]"}]}]}]}], "}"}], "*", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "I"}], "*", "m", "*", "\[Phi]"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"eout", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "/", 
       RowBox[{"(", 
        RowBox[{"I", "*", "\[Omega]", "*", "\[Epsilon]0"}], ")"}]}], "*", 
      RowBox[{"Curl", "[", 
       RowBox[{
        RowBox[{"hout", "[", 
         RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "\[Phi]", ",", "z"}], "}"}], ",", " ", 
        "\"\<Cylindrical\>\""}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hPML", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", " ", 
     RowBox[{
      RowBox[{"hout", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{"r", "\[Rule]", 
        RowBox[{"rInt", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "I"}], ")"}], "*", "\[Sigma]0", "*", 
          RowBox[{"(", 
           RowBox[{"r", "-", "rInt"}], ")"}]}]}]}], "}"}]}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{
     "Note", " ", "the", " ", "coordinate", " ", "transforms", " ", "used"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ePML", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", " ", 
     RowBox[{
      RowBox[{"eout", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{"r", "\[Rule]", 
        RowBox[{"rInt", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "I"}], ")"}], "*", "\[Sigma]0", "*", 
          RowBox[{"(", 
           RowBox[{"r", "-", "rInt"}], ")"}]}]}]}], "}"}]}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "Note", " ", "the", " ", "coordinate", " ", "transforms", " ", "used"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"Boundary", " ", "conditions"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"ruleA", " ", "=", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ePML", "[", 
          RowBox[{"rExt", ",", "0", ",", "\[Omega]"}], "]"}], ".", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], " ", "==", " ", "0"}], 
       ",", "A"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ePML", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"ePML", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleA", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hPML", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"hPML", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleA", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"eout", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"eout", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleA", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hout", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"hout", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleA", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ruleB", " ", "=", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"eout", "[", 
          RowBox[{"rCyl", ",", "0", ",", "\[Omega]"}], "]"}], ".", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], " ", "==", " ", 
        RowBox[{
         RowBox[{"n", "^", "2"}], "*", 
         RowBox[{
          RowBox[{"ein", "[", 
           RowBox[{"rCyl", ",", "0", ",", "\[Omega]"}], "]"}], ".", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}]}], ",", "B"}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ePML", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"ePML", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleB", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hPML", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"hPML", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleB", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"eout", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"eout", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleB", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"hout", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "\[Omega]_"}], "]"}], "=", 
     RowBox[{
      RowBox[{"hout", "[", 
       RowBox[{"r", ",", "\[Phi]", ",", "\[Omega]"}], "]"}], "/.", 
      RowBox[{"ruleB", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"rule\[Omega]", " ", "=", " ", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ein", "[", 
          RowBox[{"rCyl", ",", "0", ",", "\[Omega]"}], "]"}], ".", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "\[Equal]", 
        RowBox[{
         RowBox[{"eout", "[", 
          RowBox[{"rCyl", ",", "0", ",", "\[Omega]"}], "]"}], ".", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "1"}], "}"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Omega]", ",", "\[Omega]0"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"\[Omega]0", "=", 
     RowBox[{"\[Omega]", "/.", "rule\[Omega]"}]}], ";", " ", 
    RowBox[{"(*", "Eigenfrequency", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Qopt", " ", "=", " ", 
     RowBox[{"Re", "[", 
      RowBox[{"\[Omega]0", "/", 
       RowBox[{"(", 
        RowBox[{"2", "*", 
         RowBox[{"Im", "[", "\[Omega]0", "]"}]}], ")"}]}], "]"}]}], ";", " ", 
    RowBox[{"(*", 
     RowBox[{"Q", "-", "factor"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"Field", " ", "components"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Einr", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"ein", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Ein\[Phi]", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"ein", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Einz", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"ein", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Eoutr", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"eout", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Eout\[Phi]", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"eout", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Eoutz", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"eout", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EPMLr", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"ePML", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EPML\[Phi]", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"ePML", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EPMLz", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"ePML", "[", 
       RowBox[{"r", ",", "0", ",", "\[Omega]0"}], "]"}], ".", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rpml", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "z_"}], "]"}], " ", "=", 
     RowBox[{"rInt", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "I"}], ")"}], "*", "\[Sigma]0", "*", 
       RowBox[{"(", 
        RowBox[{"r", "-", "rInt"}], ")"}]}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
     "PML", " ", "coordinate", " ", "transforms", " ", "and", " ", "its", " ",
       "Jacobian"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Phi]pml", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "z_"}], "]"}], " ", "=", "\[Phi]"}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"zpml", "[", 
      RowBox[{"r_", ",", "\[Phi]_", ",", "z_"}], "]"}], " ", "=", " ", "z"}], 
    ";", " ", "\[IndentingNewLine]", 
    RowBox[{"J", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"rpml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "r"}], "]"}], 
         ",", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"rpml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "\[Phi]"}], 
          "]"}], ",", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"rpml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "z"}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"\[Phi]pml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "r"}], "]"}], 
         ",", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"\[Phi]pml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "\[Phi]"}], 
          "]"}], ",", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"\[Phi]pml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "z"}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"zpml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "r"}], "]"}], 
         ",", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"zpml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "\[Phi]"}], 
          "]"}], ",", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"zpml", "[", 
            RowBox[{"r", ",", "\[Phi]", ",", "z"}], "]"}], ",", "z"}], 
          "]"}]}], "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"J", "//", "MatrixForm"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Jinv", " ", "=", " ", 
     RowBox[{"Inverse", "[", "J", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Jinv", "//", "MatrixForm"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Moving", " ", "boundary", " ", "calculation"}], " ", "-", " ", 
      RowBox[{"QNM", " ", "perturbation", " ", "theory"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Gmbarg", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[Omega]0"}], "/", "2"}], "*", 
      RowBox[{
       RowBox[{"U", "[", "r", "]"}], ".", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"n", "^", "2"}], "-", "1"}], ")"}], "*", 
         SuperscriptBox[
          RowBox[{"Ein\[Phi]", "[", "r", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"n", "^", "2"}], "-", "1"}], ")"}], "*", 
         SuperscriptBox[
          RowBox[{"Einz", "[", "r", "]"}], "2"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1", "/", 
            RowBox[{"n", "^", "2"}]}], "-", "1"}], ")"}], "*", 
         RowBox[{"n", "^", "4"}], "*", 
         SuperscriptBox[
          RowBox[{"Einr", "[", "r", "]"}], "2"]}]}], ")"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Normalization", " ", "-", " ", 
       RowBox[{
       "Note", " ", "that", " ", "since", " ", "this", " ", "is", " ", "a", 
        " ", "traveling"}], "-", 
       RowBox[{"wave", " ", "resonator"}]}], ",", " ", 
      RowBox[{
       RowBox[{
       "some", " ", "factors", " ", "show", " ", "up", " ", "with", " ", 
        "negative", " ", "signs", " ", "to", " ", "compensate", " ", "for", 
        " ", "the", " ", "fact", " ", "that", " ", "left", " ", "and", " ", 
        "right", " ", "eigenvectors", " ", "are", " ", "counter"}], "-", 
       RowBox[{"propagating", " ", "modes"}]}]}], "*)"}], 
    RowBox[{"Energynorm", "=", 
     RowBox[{"2", "*", "\[Pi]", "*", "L", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"n", "^", "2"}], "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox[
               RowBox[{"Einr", "[", "r", "]"}], "2"]}], "+", 
             SuperscriptBox[
              RowBox[{"Ein\[Phi]", "[", "r", "]"}], "2"], "-", 
             SuperscriptBox[
              RowBox[{"Einz", "[", "r", "]"}], "2"]}], ")"}], "*", "r"}], ",", 
          RowBox[{"{", 
           RowBox[{"r", ",", "0", ",", "rCyl"}], "}"}]}], "]"}], "+", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox[
               RowBox[{"Eoutr", "[", "r", "]"}], "2"]}], "+", 
             SuperscriptBox[
              RowBox[{"Eout\[Phi]", "[", "r", "]"}], "2"], "-", 
             SuperscriptBox[
              RowBox[{"Eoutz", "[", "r", "]"}], "2"]}], ")"}], "*", "r"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"r", ",", "rCyl", ",", "rInt"}], "}"}]}], "]"}], "+", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox[
               RowBox[{"Eoutr", "[", "r", "]"}], "2"]}], "+", 
             SuperscriptBox[
              RowBox[{"Eout\[Phi]", "[", "r", "]"}], "2"], "-", 
             SuperscriptBox[
              RowBox[{"Eoutz", "[", "r", "]"}], "2"]}], ")"}], "*", "r"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"r", ",", 
            RowBox[{"rpml", "[", 
             RowBox[{"rInt", ",", "0", ",", "0"}], "]"}], ",", 
            RowBox[{"rpml", "[", 
             RowBox[{"rExt", ",", "0", ",", "0"}], "]"}]}], "}"}]}], "]"}]}], 
       ")"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"g0MB", "=", 
     RowBox[{"2", "*", "\[Pi]", "*", "L", "*", "rCyl", "*", 
      RowBox[{
       RowBox[{"Gmbarg", "[", "rCyl", "]"}], "/", "Energynorm"}], "*", 
      "xzpf"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Photoelastic", " ", "calculation"}], " ", "-", " ", 
      RowBox[{"QNM", " ", "perturbation", " ", "theory"}], " ", "-", " ", 
      RowBox[{"NOT", " ", "USED", " ", "IN", " ", "TEXT"}]}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"gpearg", "[", "r_", "]"}], "=", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"n", "^", "4"}]}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"p11", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             RowBox[{"S1", "[", "r", "]"}]}], "*", 
            SuperscriptBox[
             RowBox[{"Einr", "[", "r", "]"}], "2"]}], "+", 
           RowBox[{
            RowBox[{"S2", "[", "r", "]"}], "*", 
            SuperscriptBox[
             RowBox[{"Ein\[Phi]", "[", "r", "]"}], "2"]}]}], ")"}]}], "+", 
        RowBox[{"p12", "*", 
         RowBox[{"S1", "[", "r", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Ein\[Phi]", "[", "r", "]"}], "2"], "-", 
           SuperscriptBox[
            RowBox[{"Einz", "[", "r", "]"}], "2"]}], ")"}]}], "+", 
        RowBox[{"p12", "*", 
         RowBox[{"S2", "[", "r", "]"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{"Einr", "[", "r", "]"}], "2"]}], "-", 
           SuperscriptBox[
            RowBox[{"Einz", "[", "r", "]"}], "2"]}], ")"}]}]}], ")"}]}]}], 
    ";", 
    RowBox[{"g0PE", "=", 
     RowBox[{
      RowBox[{"-", "xzpf"}], "*", 
      RowBox[{"\[Omega]0", "/", "2"}], "*", "2", "*", "\[Pi]", "*", "L", "*", 
      RowBox[{
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"gpearg", "[", "r", "]"}], "*", "r"}], ",", 
         RowBox[{"{", 
          RowBox[{"r", ",", "0", ",", "rCyl"}], "}"}]}], "]"}], "/", 
       "Energynorm"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"g02\[Pi]", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g0MB", "+", "g0PE"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "\[Pi]"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ii", "\[Equal]", "0"}], ",", 
      RowBox[{"\[Omega]ini", "=", "\[Omega]0"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ii", "\[Equal]", "1"}], ",", 
      RowBox[{"\[Omega]fin", "=", "\[Omega]0"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"Exact", " ", "frequency", " ", "pulling"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"g0MBexa", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Omega]fin", "-", "\[Omega]ini"}], ")"}], "/", 
       "\[Delta]r"}], "*", "xzpf"}]}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", "g0MBexa", "\[IndentingNewLine]", "g0MB", "\
\[IndentingNewLine]", 
 RowBox[{"Qopt", ";"}], "\[IndentingNewLine]", 
 RowBox[{"\[Omega]ini", "/", 
  RowBox[{"(", 
   RowBox[{"2", "\[Pi]"}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Err", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"g0MBexa", "-", "g0MB"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"Max", "[", 
      RowBox[{
       RowBox[{"Abs", "[", "g0MB", "]"}], ",", 
       RowBox[{"Abs", "[", "g0MBexa", "]"}]}], "]"}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.789811440116866*^9, 3.78981149192624*^9}, {
   3.789811549414276*^9, 3.7898115902639866`*^9}, {3.789813312981025*^9, 
   3.789813313506589*^9}, {3.7898133446949615`*^9, 3.789813350964505*^9}, {
   3.789813408962344*^9, 3.789813410881153*^9}, {3.7898174325865965`*^9, 
   3.7898174865531874`*^9}, {3.7898175399173975`*^9, 3.789817562579755*^9}, {
   3.789817681871641*^9, 3.78981768572832*^9}, {3.7898281288655214`*^9, 
   3.789828382350318*^9}, {3.7898284185752754`*^9, 3.789828458841423*^9}, {
   3.789828512342472*^9, 3.789828565947674*^9}, 3.789828782642735*^9, {
   3.78982882942091*^9, 3.7898288307109814`*^9}, {3.789828891884787*^9, 
   3.7898288938800435`*^9}, {3.806346687159786*^9, 3.8063467889620347`*^9}, {
   3.806347302051448*^9, 
   3.8063473281941833`*^9}},ExpressionUUID->"f0a76118-8af7-4a2c-9c4b-\
8d3bffdd60b2"]
},
WindowSize->{2048, 1069},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
Magnification:>1.4 Inherited,
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 5540, 124, 502, "Input",ExpressionUUID->"86be686d-a79b-427d-aa4a-d89615fb0bb5"],
Cell[CellGroupData[{
Cell[6123, 148, 7607, 200, 874, "Input",ExpressionUUID->"0739c0c9-5bc1-4a58-b921-a515cb629d4d"],
Cell[13733, 350, 1088, 16, 46, "Output",ExpressionUUID->"4bc3f9ef-8e5b-4c5f-ad7a-635c0c62a2ac"]
}, Open  ]],
Cell[14836, 369, 23233, 618, 2377, "Input",ExpressionUUID->"f0a76118-8af7-4a2c-9c4b-8d3bffdd60b2"]
}
]
*)

